import fr.cnam.provider.*;
import java.rmi.*;

// Creation du producteur (classe applicative)
public class Producteur implements Supplier
{
  private SupplierImpl supplier;

  public Producteur(int canal)throws Exception{
    supplier = new SupplierImpl(canal);

    // Pour que le Consommateur Applicatif puisse tirer une information au producteur
    supplier.setSupplier(this); 
  }

  private int compteur; // valeur qui est tiree

  // Algorithme qui pousse des objets aux consommateurs
  public void produire()
  {
    try{
      int n=0;
      while(true) 
        {
          System.out.println("MESSAGE "+n);

          // On pousse un objet
          supplier.push("MESSAGE "+ n++);
          try{Thread.sleep(1000);}catch(Exception ex){ex.printStackTrace();};
        }
    }catch(Exception ex){};
  }
  
  // Traitement qui simule la cration d'un venement dans le producteur qui est tire par les consommateurs
  public Object pull()
  {
    return ">>>  "+ compteur++;
  }

  // ================================================================
  // args[0] : numro du canal sur lequel le Producteur Applicatif pousse un objet
  //
  public static void main(String... args) throws Exception
  {
    // Creation d'un producteur sur un canal
    Producteur p = new Producteur(Integer.parseInt(args[0]));

    // Pour produire rgulirement des informations aux consommateurs
    p.produire();
  }
}