package fr.cnam.provider;

import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.*;
import java.util.*;
import java.io.*;

// Classe de dfinition d'un consommateur sur un canal de comunication
//
public class ConsumerImpl extends UnicastRemoteObject implements Consumer
{
  private Consumer consumer;  // L'objet utilis par le Consommateur pour qu'on lui pousse un objet
  private Supplier supplier;  // La connexion distante au Proxy du Producteur

 // Cration d'un consommateur sur un canal de communication
  //  canal : le numro (0  9) du canal
  //
  public ConsumerImpl(int canal)  throws Exception
  {
    consumer=null;
    supplier = ProviderImpl.getProvider().connectConsumer((Consumer)(UnicastRemoteObject.toStub(this)),canal);
  }

  // Brancher l'objet utilis par le Consommateur pour qu'on lui pousse une objet
  //
  public void setConsumer(Consumer consumer){this.consumer=consumer;}

  // Pour pousser un objet
  //
  public void push(Object obj) throws RemoteException
  {
    try{
      if (consumer==null) throw new RuntimeException("push non implment dans le consommateur");
      consumer.push(obj);
    }catch(Exception ex){}
  }

  // Pour tirer un objet
  //
  public Object pull()throws Exception{
    return supplier.pull();
  }


}