package fr.cnam.provider;

import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.*;
import java.util.*;

// Proxy utilise par chacun des consommateurs
public class ProxySupplier extends UnicastRemoteObject implements Supplier
{
  private ProxyConsumer proxyConsumer;  // utilise pour tirer aus producteurs connectes au canal
  private Consumer      consumer;       // Le consommateur

  public ProxySupplier(Consumer c,ProxyConsumer pc)  throws RemoteException
  {
    super(9101);
    consumer=c;
    proxyConsumer=pc;
  }

  // Pousser au consommateur
  public void push(Object obj) throws RemoteException
  {
    consumer.push(obj);
  }

  // Tirer aux producteurs
  public Object pull() throws RemoteException
  {
    return proxyConsumer.pull();
  }
}