package fr.cnam.provider;

import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.*;
import java.util.*;
import java.io.*;

// Classe de dfinition d'un producteur sur un canal de communication
//
public class SupplierImpl extends UnicastRemoteObject implements Supplier
{  
  
  private Consumer consumer;  //  La connexion distante au Proxy des consommateurs  
  private Supplier supplier;  // L'objet utilis par le Producteur pour qu'on lui tire une objet

  // Cration d'un producteur sur un canal de communication
  //  canal : le numro (0  9) du canal
  //
  public SupplierImpl(int canal)  throws Exception
  {
    this.supplier=null;
    Supplier sup = (Supplier)(UnicastRemoteObject.toStub(this));
    consumer = ProviderImpl.getProvider().connectSupplier(sup,canal);
  }

  // Brancher l'objet utilis par le Producteur pour qu'on lui tire une objet
  //
  public void setSupplier(Supplier supplier){
    this.supplier=supplier;
  }

  // Pour pousser un objet
  //
  public void push(Object o)throws Exception{
    consumer.push(o);
  }

  // Pour tirer un objet
  //
  public Object pull() throws RemoteException
  {
    if (supplier==null) throw new RuntimeException("pull non implment dans le producteur");
    try{
      return supplier.pull();
    }catch(Exception ex){return null;}
  }

}